package owg.competent;

/**Exception thrown by Competent Audio functions.*/
public class CAException extends RuntimeException
{
	/**The error code that caused this exception*/
	public final CAErrorCode code;
	
	public CAException(CAErrorCode code)
	{
		this(code, null);
	}
	public CAException(CAErrorCode code, String args)
	{
		this(code, args, null);
	}
	public CAException(CAErrorCode code, String args, Throwable cause)
	{
		super(code.name()+": "+code.description+
				(args!=null?" ("+args+")":""), cause);
		this.code = code;
	}
	/**Throws a CAException if the result is negative.*/
	public static int throwIfError(int result) throws CAException
	{
		if(result < 0)
			throw new CAException(CAErrorCode.getError(result));
		return result;
	}
}
